<?php
/**
*
* @package jserrlog
* @copyright (c) 2015 c61 c61@yandex.ru http://c61.su
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

namespace c61\jserrlog\acp;

class jserrlog_module
{
	var $u_action;
	var $max_rep_id;
	var $step = 1000;

	function main($id, $mode)
	{
		global $cache, $config, $db, $user, $auth, $template, $request;
		global $phpbb_root_path, $phpEx, $phpbb_admin_path, $phpbb_container;

		$this->page_title = 'ACP_JSERRLOG';
		$this->tpl_name = 'acp_jserrlog';
		
		$submit = (isset($_POST['submit'])) ? true : false;
		$form_key = 'config_jserrlog';
		add_form_key($form_key);
		
		$display_vars = array(
			'title'	=> 'ACP_JSERRLOG',
			'vars'	=> array(
				'legend1'				=> 'ACP_JSERRLOG_ONOFF',
				'jserrlog_onoff_jserrlog'		=> array('lang' => 'ACP_JSERRLOG_ONOFF_JSERRLOG', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'jserrlog_onoff_debug'			=> array('lang' => 'ACP_JSERRLOG_DEBUG', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'jserrlog_ignore'				=> array('lang' => 'ACP_JSERRLOG_IGNORE', 'validate' => 'string',	'type' => 'text:40:40', 'explain' => true),
				'jserrlog_thisonly'				=> array('lang' => 'ACP_JSERRLOG_THISONLY', 'validate' => 'string',	'type' => 'text:40:40', 'explain' => true),
				'jserrlog_maxrep'				=> array('lang' => 'ACP_JSERRLOG_MAXREP', 'validate' => 'int:0:99',	'type' => 'number:0:99', 'explain' => true),
				'jserrlog_trap'					=> array('lang' => 'ACP_JSERRLOG_TRAP', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'jserrlog_console'				=> array('lang' => 'ACP_JSERRLOG_CONSOLE', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'jserrlog_crossorigin'			=> array('lang' => 'ACP_JSERRLOG_CROSSORIGIN', 'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
			
				'legend2'				=> 'ACP_SUBMIT_CHANGES',
			),
		);
						
		if (isset($display_vars['lang']))
		{
			$user->add_lang($display_vars['lang']);
		}

		$this->new_config = $config;
		$cfg_array = (isset($_REQUEST['config'])) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : $this->new_config;
		$error = array();

		// We validate the complete config if wished
		validate_config_vars($display_vars['vars'], $cfg_array, $error);

		if ($submit && !check_form_key($form_key))
		{
			$error[] = $user->lang['FORM_INVALID'];
		}
		// Do not write values if there is an error
		if (sizeof($error))
		{
			$submit = false;
		}
		
		// We go through the display_vars to make sure no one is trying to set variables he/she is not allowed to...
		foreach ($display_vars['vars'] as $config_name => $null)
		{
			if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false)
			{
				continue;
			}

			$this->new_config[$config_name] = $config_value = $cfg_array[$config_name];

			if ($submit)
			{
				set_config($config_name, $config_value);
			}
		}
		
		if ($submit)
		{
			trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
		}
		
		$this->page_title = $display_vars['title'];
		
		$template->assign_vars(array(
			'L_TITLE'				=> $user->lang[$display_vars['title']],
			'L_TITLE_EXPLAIN'		=> $user->lang[$display_vars['title'] . '_EXPLAIN'],
			'L_TITLE_DESCRIPTION'	=> $user->lang[$display_vars['title'] . '_DESCRIPTION'],

			'S_ERROR'			=> (sizeof($error)) ? true : false,
			'ERROR_MSG'			=> implode('<br />', $error),
		));
		
		// Output relevant page
		foreach ($display_vars['vars'] as $config_key => $vars)
		{
			if (!is_array($vars) && strpos($config_key, 'legend') === false)
			{
				continue;
			}

			if (strpos($config_key, 'legend') !== false)
			{
				$template->assign_block_vars('options', array(
					'S_LEGEND'		=> true,
					'LEGEND'		=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
				);

				continue;
			}

			$type = explode(':', $vars['type']);

			$l_explain = '';
			if ($vars['explain'] && isset($vars['lang_explain']))
			{
				$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
			}
			else if ($vars['explain'])
			{
				$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
			}

			$l_description = (isset($user->lang[$vars['lang'] . '_DESCRIPTION'])) ? $user->lang[$vars['lang'] . '_DESCRIPTION'] : '';

			$content = build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars);

			if (empty($content))
			{
				continue;
			}

			$template->assign_block_vars('options', array(
				'KEY'			=> $config_key,
				'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
				'S_EXPLAIN'		=> $vars['explain'],
				'TITLE_EXPLAIN'	=> $l_explain,
				'TITLE_DESCRIPTION'	=> $l_description,
				'CONTENT'		=> $content,
				)
			);

			unset($display_vars['vars'][$config_key]);
		}
	}
}

?>