<?php
/**
*
* @package jserrlog
* @copyright (c) 2015 c61 c61@yandex.ru http://c61.su
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

namespace c61\jserrlog\migrations\v0xx;

class jserrlog_v_0_0_1 extends \phpbb\db\migration\migration
{
	public function effectively_installed()
	{
		return isset($this->config['jserrlog_version']) && version_compare($this->config['jserrlog_version'], '0.0.1', '>=');
	}

	static public function depends_on()
	{
			return array('\phpbb\db\migration\data\v310\dev');
	}

	public function update_schema()
	{
		return array(
		);
	}

	public function revert_schema()
	{
		return array(
		);
	}

	public function update_data()
	{
		return array(
			// Add configs
			array('config.add', array('jserrlog_onoff_jserrlog', '1')),
			array('config.add', array('jserrlog_onoff_debug', '0')),
			array('config.add', array('jserrlog_ignore', '[]')),
			array('config.add', array('jserrlog_thisonly', '[]')),
			array('config.add', array('jserrlog_maxrep', 10)),
			array('config.add', array('jserrlog_trap', 0)),
			array('config.add', array('jserrlog_console', 0)),
			array('config.add', array('jserrlog_crossorigin', 0)),

			// Current version
			array('config.add', array('jserrlog_version', '0.0.1')),

			// Add ACP modules
			array('module.add', array('acp', 'ACP_CAT_DOT_MODS', 'ACP_JSERRLOG')),
			array('module.add', array('acp', 'ACP_JSERRLOG', array(
					'module_basename'	=> '\c61\jserrlog\acp\jserrlog_module',
					'module_langname'	=> 'ACP_JSERRLOG_EXPLAIN',
					'module_mode'		=> 'config_jserrlog',
					'module_auth'		=> 'acl_a_jserrlog',
			))),
			
			// Add permissions
			array('permission.add', array('a_jserrlog', true)),

			// Set permissions
			array('permission.permission_set', array('ROLE_ADMIN_FULL', 'a_jserrlog')),
		);
	}
}